#include "parms_mat.h"

#if defined(FORTRAN_CAPS)
#define parms_matapply_           PARMS_MATAPPLY        
#define parms_matcreate_ 	  PARMS_MATCREATE       
#define parms_matfree_ 		  PARMS_MATFREE         
#define parms_matmvpy_ 		  PARMS_MATMVPY         
#define parms_matsetcommtype_ 	  PARMS_MATSETCOMMTYPE  
#define parms_matsetilutype_ 	  PARMS_MATSETILUTYPE   
#define parms_matsettype_ 	  PARMS_MATSETTYPE      
#define parms_matsetvalues_ 	  PARMS_MATSETVALUES    
#define parms_matsetup_ 	  PARMS_MATSETUP        
#define parms_matvec_ 		  PARMS_MATVEC          
#define parms_matview_         	  PARMS_MATVIEW         
#define #elif defined(FORTRAN_DOUBLE_UNDERSCORE)
#define parms_matapply_           parms_matapply__        
#define parms_matcreate_ 	  parms_matcreate__       
#define parms_matfree_ 		  parms_matfree__         
#define parms_matmvpy_ 		  parms_matmvpy__         
#define parms_matsetcommtype_ 	  parms_matsetcommtype__  
#define parms_matsetilutype_ 	  parms_matsetilutype__   
#define parms_matsettype_ 	  parms_matsettype__      
#define parms_matsetvalues_ 	  parms_matsetvalues__    
#define parms_matsetup_ 	  parms_matsetup__        
#define parms_matvec_ 		  parms_matvec__          
#define parms_matview_         	  parms_matview__         
#elif !defined(FORTRAN_UNDERSCORE)
#define parms_matapply_           parms_matapply        
#define parms_matcreate_ 	  parms_matcreate       
#define parms_matfree_ 		  parms_matfree         
#define parms_matmvpy_ 		  parms_matmvpy         
#define parms_matsetcommtype_ 	  parms_matsetcommtype  
#define parms_matsetilutype_ 	  parms_matsetilutype   
#define parms_matsettype_ 	  parms_matsettype      
#define parms_matsetvalues_ 	  parms_matsetvalues    
#define parms_matsetup_ 	  parms_matsetup        
#define parms_matvec_ 		  parms_matvec          
#define parms_matview_         	  parms_matview         
#endif

void parms_matapply_(parms_Mat *self, parms_Vec *x, parms_Vec *y, int
		     *ierr)  
{
  *ierr = parms_MatApply(*self, *x, *y);
}

void parms_matcreate_(parms_Mat *self, parms_Map *map, int *ierr)        
{
  *ierr = parms_MatCreate(self, *map);
}

void parms_matfree_(parms_Mat *self, int *ierr)          
{
  *ierr = parms_MatFree(self);
}

void parms_matmvpy_(parms_Mat *self, REAL *alpha, parms_Vec *x, REAL
		    *beta, parms_Vec *y, parms_Vec *z, int *ierr)
{
  *ierr = parms_MatMVPY(*self, *alpha, *x, *beta, *y, *z);
}

void parms_matsetcommtype_(parms_Mat *self, COMMTYPE *ctype, int
			   *ierr)
{
  *ierr = parms_MatSetCommType(*self, *ctype);
}

void parms_matsetilutype_(parms_Mat *self, PCILUTYPE *type, int *ierr)
{
  *ierr = parms_MatSetILUType(*self, *type);
}

void parms_matsettype_(parms_Mat *self, MATTYPE *type, int *ierr)       
{
  *ierr = parms_MatSetType(*self, *type);
}

void parms_matsetvalues_(parms_Mat *self, int *m, int *im, int *ia,
			 int *ja, FLOAT *values, INSERTMODE *mode, int
			 *ierr)  
{
  *ierr = parms_MatSetValues(*self, *m, im, ia, ja, values, *mode);
}

void parms_matsetup_(parms_Mat *self, int *ierr)
{
  *ierr = parms_MatSetup(*self);
}

void parms_matvec_(parms_Mat *self, parms_Vec *x, parms_Vec *y, int
		   *ierr) 
{
  *ierr = parms_MatVec(*self, *x, *y);
}

void parms_matview_(parms_Mat *self, parms_Viewer *v, int *ierr)        
{
  *ierr = parms_MatView(*self, *v);
}
