#include "parms_solver.h"

#if defined(FORTRAN_CAPS)
#define parms_solverapply_      PARMS_SOLVERAPPLY
#define parms_solvercreate_	  PARMS_SOLVERCREATE
#define parms_solverfree_	  PARMS_SOLVERFREE
#define parms_solvergetits_	  PARMS_SOLVERGETITS
#define parms_solvergetmat_	  PARMS_SOLVERGETMAT
#define parms_solversetparam_	  PARMS_SOLVERSETPARAM
#define parms_solversettype_	  PARMS_SOLVERSETTYPE
#define parms_solversetup_	  PARMS_SOLVERSETUP
#elif defined(FORTRAN_DOUBLE_UNDERSCORE)
#define parms_solverapply_      parms_solverapply__
#define parms_solvercreate_	  parms_solvercreate__
#define parms_solverfree_	  parms_solverfree__
#define parms_solvergetits_	  parms_solvergetits__
#define parms_solvergetmat_	  parms_solvergetmat__
#define parms_solversetparam_	  parms_solversetparam__
#define parms_solversettype_	  parms_solversettype__
#define parms_solversetup_	  parms_solversetup__
#elif !defined(FORTRAN_UNDERSCORE)
#define parms_solverapply_      parms_solverapply
#define parms_solvercreate_	  parms_solvercreate
#define parms_solverfree_	  parms_solverfree
#define parms_solvergetits_	  parms_solvergetits
#define parms_solvergetmat_	  parms_solvergetmat
#define parms_solversetparam_	  parms_solversetparam
#define parms_solversettype_	  parms_solversettype
#define parms_solversetup_	  parms_solversetup
#endif

void parms_solverapply_(parms_Solver *self, parms_Vec *x, parms_Vec
			*y, int *ierr)
{
  *ierr = parms_SolverApply(*self, *x, *y);
}

void parms_solvercreate_(parms_Solver *self, parms_Mat *A, parms_PC
			 *pc, int *ierr)
{
  *ierr = parms_SolverCreate(self,  *A,  *pc);
}

void parms_solverfree_(parms_Solver *self, int *ierr)
{
  *ierr = parms_SolverFree(self);
}

void parms_solvergetits_(parms_Solver *self, int *its, int *ierr)
{
  *its = parms_SolverGetIts(*self);
  *ierr = 0;
}

void parms_solvergetmat_(parms_Solver *self, parms_Mat *A, int *ierr)
{
  *ierr = parms_SolverGetMat(*self,  A);
}

void parms_solversetparam_(parms_Solver *self, PARAMTYPE *ptype, char
			   *param, int *ierr)
{
  parms_SolverSetParam(*self, *ptype, param);
  *ierr = 0;
}

void parms_solversettype_(parms_Solver *self, SOLVERTYPE *stype, int
			  *ierr)
{
  *ierr = parms_SolverSetType(*self, *stype);
}

void parms_solversetup_(parms_Solver *self, int *ierr)
{
  *ierr = parms_SolverSetup(*self);
}

